<?php

namespace App\Model;

class SalesOrder extends UseScopeBaseModel
{
    protected $table = "sales_order"; //指定表
    const CREATED_AT = 'crt_time';
    const UPDATED_AT = 'upd_time';
    protected $dateFormat = 'U';
    const range_function = 'salesOrderRange';
    const Order_type_one = 1;//安装件
    const Order_type_two = 2;//快递件
    public static $order_type = [
        self::Order_type_one => '安装件',
        self::Order_type_two => '快递件',
    ];

    const Model_type_one = 1; // 线下订单合同
    const Model_type_two = 2; // 分社订货合同
    const Model_type_three = 3; // 二手车精品加装合同
    public static $model_type = [
        self::Model_type_one,
        self::Model_type_two,
        self::Model_type_three
    ];
    public static $model_type_title = [
        self::Model_type_one => '线下订单合同',
        self::Model_type_two => '分社订货合同',
        self::Model_type_three => '二手车精品加装合同',
    ];

    //安装件
    const State_zero = 0;//未确认
    const State_one = 1;//待确认
    const State_two = 2;//已确认
    const State_three = 3;//已派销售
    const State_four = 4;//已派总设或分社
    const State_five = 5;//已下施工单
    const State_six = 6;//退换货
    const State_seven = 7;//完结 公司
    const State_eight = 8;//完结 客户
    public static $state = [
        self::State_zero => '未确认',
        self::State_one => '待确认',
        self::State_two => '已确认',
        self::State_three => '已派销售',
        self::State_four => '已派总设或分社',
        self::State_five => '已下施工单',
        self::State_six => '退换货',
        self::State_seven => '公司完结',
        self::State_eight => '客户完结',
    ];

    //快递件
    const State2_zero = 0;//未发货
    const State2_one = 1;//已发货
    public static $state2 = [
        self::State2_zero => '未发货',
        self::State2_one => '已发货',
    ];

    public static $prefix = [
        self::Model_type_one => 'T9XS.',
        self::Model_type_two => 'T9SO.',
        self::Model_type_three => 'T9XS.'
    ];
}
